// ComObject.h
#pragma once

#include <loki/Typelist.h>
#include <loki/TypeManip.h>
#include <loki/static_check.h>
#include <atlbase.h>

namespace Private
{
	////////////////////////////////////////////////////////////////////////////////
	/// TList ̂ꂼ̗vf Element ɑ΂APred<Target, Element>Ăяo.
	/// JԂƂ Target = Pred<Target, Element>::Result TargetƂĎgp.
	template < class TList, class Target, template <class, class> class Pred >
	struct Fold
	{
		typedef typename Fold<
			typename TList::Tail,	// c
			typename Pred<Target, typename TList::Head>::Result,	// Head ̌
			Pred
		>::Result Result;
	};
	template < class Target, template <class, class> class Pred >
	struct Fold<Loki::NullType, Target, Pred>
	{
		typedef Target Result;
	};

	////////////////////////////////////////////////////////////////////////////////
	/// TList  T p̉̃NX܂܂ĂꍇATListT.
	template < class TList, class T >
	struct RemoveIfNotMostDerived
	{
		typedef typename Loki::Select<
			Loki::IsSameType<T, typename Loki::TL::MostDerived<TList, T>::Result>::value,
			TList,
			typename Loki::TL::Erase<TList, T>::Result
		>::Result Result;
	};

	////////////////////////////////////////////////////////////////////////////////
	/// TList ׂ̒̂Ă̌^́A㗬̌^܂܂ĂȂ悤ɂ.
	template < class TList >
	struct MostDerivedOnly
	{
		typedef typename Fold<TList, TList, RemoveIfNotMostDerived>::Result Result;
	};

	////////////////////////////////////////////////////////////////////////////////
	/// TList Ɋ܂܂邷ׂĂ̌^𑽏dpNX`.
	/// GenScatterHierarchy𗘗pꍇ͗]vtableǉ邪ÃNXł͍œKĂ.
	template < class TList >
	struct __declspec(novtable) Inherits : TList::Head, Inherits<typename TList::Tail>
	{
		typedef typename TList::Head	Head;
		typedef typename TList::Tail	Tail;
	};
	template <>
	struct __declspec(novtable) Inherits<Loki::NullType>
	{};

	// QueryInterface.
	template < class BaseList, class QueryList >
	class __declspec(novtable) InterfaceList : public Inherits<BaseList>
	{
	public:
		typedef typename BaseList::Head MostLeftInterface; ///< łuṽC^tF[X.
	public: // IUnknown
		STDMETHODIMP QueryInterface(REFIID iid, void** ppObject) throw()
		{
			if(ppObject == NULL)
				return E_INVALIDARG;
			return InternalQueryInterface<QueryList>(iid, ppObject);
		}

	protected:
		InterfaceList() throw()	{}
		virtual ~InterfaceList() throw()	{}
	private: // non-copyable
		InterfaceList(const InterfaceList&);
		InterfaceList& operator = (const InterfaceList&);

	private:
		template < class TList >
		STDMETHODIMP InternalQueryInterface(REFIID iid, void** ppObject) throw()
		{
			typedef typename TList::Head Interface;
			STATIC_CHECK( SUPERSUBCLASS(IUnknown, Interface), Interface_is_not_deerived_from_IUnknown );
			if(iid == __uuidof(Interface))
			{
				Interface* pInterface = static_cast<Interface*>(static_cast<Loki::TL::MostDerived<BaseList, Interface>::Result*>(this));
				*ppObject = pInterface;
				pInterface->AddRef();
				return S_OK;
			}
			else
				return InternalQueryInterface<TList::Tail>(iid, ppObject);
		}
		template <>
		STDMETHODIMP InternalQueryInterface<Loki::NullType>(REFIID iid, void** ppObject) throw()
		{
			if(iid == __uuidof(IUnknown))
			{
				IUnknown* pInterface = static_cast<IUnknown*>(static_cast<MostLeftInterface*>(this));
				*ppObject = pInterface;
				pInterface->AddRef();
				return S_OK;
			}
			else
			{
				*ppObject = NULL;
				return E_NOINTERFACE;
			}
		}
	};

	template < class TList >
	struct ObjectHelper
	{
		// ۂɂ́A\[gĂKv͖
		typedef typename Loki::TL::DerivedToFront<TList>::Result	QueryList;
		// QueryList ̂Ǎ^ɓ^菜iIStream  ISequentialStream ̊֌Wj
		typedef typename MostDerivedOnly<QueryList>::Result				BaseList;
		//
		typedef InterfaceList<BaseList, QueryList>	Result;
	};
}

/// IUnknown ̎̂ЂƂ.
/// q[vɍIuWFNg̎QƃJEgǗ.
template < class TRoot >
class __declspec(novtable) DynamicClass : public TRoot
{
protected:
	volatile LONG m_ReferenceCount;
	DynamicClass() throw() : m_ReferenceCount(1)
	{
	}
#ifdef _DEBUG
	~DynamicClass() throw()
	{
		ATLASSERT(m_ReferenceCount == 0 && "QƃJEg[ɂȂOɍ폜܂");
	}
#endif
public:
	ULONG __increment__() throw()
	{
		return ::InterlockedIncrement(&m_ReferenceCount);
	}
	ULONG __decrement__() throw()
	{
		return ::InterlockedDecrement(&m_ReferenceCount);
	}
};

/// IUnknown ̎̂ЂƂ.
/// X^bNɍIuWFNg̎QƃJEgǗ.
template < class TRoot >
class __declspec(novtable) StaticClass : public TRoot
{
public:
	ULONG __increment__() throw()
	{
		return 1;
	}
	ULONG __decrement__() throw()
	{
		return 1;
	}
};

/// [g.
/// @param TFinal t@CiNX. class XXX : public ComObject< XXX, TList, TBase >;
/// @param TList  C^tF[XXg.
/// @param TBase  x[XNX. 
///  - ꃁ\bh
///    - __new__(IUnknown* arg)
///    - __delete__() : QƃJEg[ɂȂ.
///    - __increment__() : QƃJEg𑝂₷.
///    - __decrement__() : QƃJEg炷.
///    - __final__ : FinalClass& ɃLXg *this Ԃ.
template < class TFinal, class TList, template < class > class TBase = DynamicClass >
class __declspec(novtable) ComObject : public TBase< typename Private::ObjectHelper<TList>::Result >
{
public:
	typedef TFinal FinalClass;

public:
	STDMETHODIMP_(ULONG) AddRef() throw()
	{
		return __final__.__increment__();
	}
	STDMETHODIMP_(ULONG) Release() throw()
	{
		ULONG refs = __final__.__decrement__();
		if(refs == 0)
		{
			delete this;
		}
		return refs;
	}

public:
	__declspec(property(get=get_final)) FinalClass& __final__;
	__forceinline FinalClass& get_final() throw()
	{
		return *static_cast<FinalClass*>(this);
	}
	__forceinline const FinalClass& get_final() const throw()
	{
		return *static_cast<const FinalClass*>(this);
	}
};
